diff --git a/src/main/java/net/minecraft/core/world/type/WorldTypeOverworldIndev.java b/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldIndev.java
similarity index 50%
rename from src/main/java/net/minecraft/core/world/type/WorldTypeOverworldIndev.java
rename to src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldIndev.java
index dc696a057..e04ce0c60 100644
--- a/src/main/java/net/minecraft/core/world/type/WorldTypeOverworldIndev.java
+++ b/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldIndev.java
@@ -1,56 +1,25 @@
-package net.minecraft.core.world.type;
+package net.minecraft.core.world.type.overworld;
 
-import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
 import net.minecraft.core.world.biome.provider.BiomeProviderSingleBiome;
-import net.minecraft.core.world.config.season.SeasonConfig;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
-import net.minecraft.core.world.generate.chunk.classic.ChunkGeneratorClassic;
 import net.minecraft.core.world.generate.chunk.indev.ChunkGeneratorIndev;
 import net.minecraft.core.world.generate.chunk.indev.IndevWorldTheme;
 import net.minecraft.core.world.generate.chunk.indev.IndevWorldType;
 import net.minecraft.core.world.generate.chunk.indev.LevelGenerator;
-import net.minecraft.core.world.season.Seasons;
-import net.minecraft.core.world.weather.Weather;
-import net.minecraft.core.world.wind.WindManagerGeneric;
 
 public class WorldTypeOverworldIndev
-    extends WorldTypeOverworld
-{
-    public WorldTypeOverworldIndev(String languageKey)
-    {
-        super(
-                languageKey,
-                Weather.overworldClear,
-                new WindManagerGeneric(),
-                SeasonConfig.builder()
-                        .withSingleSeason(Seasons.NULL)
-                        .build()
-        );
+        extends WorldTypeOverworld {
+    public WorldTypeOverworldIndev(Properties properties) {
+        super(properties);
     }
 
     @Override
-    public int getMinY()
-    {
-        return 0;
-    }
-
-    @Override
-    public int getMaxY() {
-        return 127;
-    }
-
-    @Override
-    public int getOceanY() {
-        return 64;
-    }
-
-    @Override
-    public boolean isValidSpawn(World world, int x, int y, int z)
-    {
-        return world.getBlockId(x, y, z) == Block.grass.id || world.getBlockId(x, y, z) == Block.sand.id || world.getBlockId(x, y, z) == Block.grassRetro.id;
+    public boolean isValidSpawn(World world, int x, int y, int z) {
+        return world.getBlockId(x, y, z) == Blocks.GRASS.id || world.getBlockId(x, y, z) == Blocks.SAND.id || world.getBlockId(x, y, z) == Blocks.GRASS_RETRO.id;
     }
 
     @Override
@@ -58,14 +27,12 @@ public class WorldTypeOverworldIndev
         int x = 0;
         int y = 0;
         int z = 0;
-        spawnLoop:  while (true)
-        {
+        spawnLoop:
+        while (true) {
             x = world.rand.nextInt(256);
             z = world.rand.nextInt(256);
-            for (y = getMaxY(); y >= getMinY(); y--)
-            {
-                if (world.getBlockId(x, y + 1, z) == 0 && isValidSpawn(world, x, y, z))
-                {
+            for (y = getMaxY(); y >= getMinY(); y--) {
+                if (world.getBlockId(x, y + 1, z) == 0 && isValidSpawn(world, x, y, z)) {
                     break spawnLoop;
                 }
             }
@@ -80,19 +47,12 @@ public class WorldTypeOverworldIndev
     }
 
     @Override
-    public BiomeProvider createBiomeProvider(World world)
-    {
+    public BiomeProvider createBiomeProvider(World world) {
         return new BiomeProviderSingleBiome(Biomes.OVERWORLD_RETRO, 1.0, 1.0, 1.0);
     }
 
     @Override
-    public ChunkGenerator createChunkGenerator(World world)
-    {
+    public ChunkGenerator createChunkGenerator(World world) {
         return new ChunkGeneratorIndev(world, 256, getMaxY() + 1, 256, IndevWorldType.ISLAND, IndevWorldTheme.NORMAL);
     }
-
-    @Override
-    public float getCloudHeight() {
-        return 108.0f;
-    }
 }
diff --git a/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldInland.java b/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldInland.java
new file mode 100644
index 000000000..5bb0326c0
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldInland.java
@@ -0,0 +1,16 @@
+package net.minecraft.core.world.type.overworld;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.World;
+
+public class WorldTypeOverworldInland
+        extends WorldTypeOverworld {
+    public WorldTypeOverworldInland(Properties properties) {
+        super(properties);
+    }
+
+    @Override
+    public boolean isValidSpawn(World world, int x, int y, int z) {
+        return world.getBlockId(x, y, z) == Blocks.GRASS.id;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldParadise.java b/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldParadise.java
new file mode 100644
index 000000000..4ada2848a
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldParadise.java
@@ -0,0 +1,15 @@
+package net.minecraft.core.world.type.overworld;
+
+import net.minecraft.core.world.World;
+
+public class WorldTypeOverworldParadise
+        extends WorldTypeOverworld {
+    public WorldTypeOverworldParadise(Properties properties) {
+        super(properties);
+    }
+
+    @Override
+    public float getCelestialAngle(World world, long tick, float partialTick) {
+        return 0.0f;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldRetro.java b/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldRetro.java
new file mode 100644
index 000000000..18e81b245
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldRetro.java
@@ -0,0 +1,25 @@
+package net.minecraft.core.world.type.overworld;
+
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biomes;
+import net.minecraft.core.world.biome.provider.BiomeProvider;
+import net.minecraft.core.world.biome.provider.BiomeProviderSingleBiome;
+import net.minecraft.core.world.generate.chunk.ChunkGenerator;
+import net.minecraft.core.world.generate.chunk.perlin.overworld.retro.ChunkGeneratorOverworldRetro;
+
+public class WorldTypeOverworldRetro
+        extends WorldTypeOverworld {
+    public WorldTypeOverworldRetro(Properties properties) {
+        super(properties);
+    }
+
+    @Override
+    public BiomeProvider createBiomeProvider(World world) {
+        return new BiomeProviderSingleBiome(Biomes.OVERWORLD_RETRO, 1.0, 1.0, 1.0);
+    }
+
+    @Override
+    public ChunkGenerator createChunkGenerator(World world) {
+        return new ChunkGeneratorOverworldRetro(world);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldSkyblock.java b/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldSkyblock.java
new file mode 100644
index 000000000..50f5f00a3
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldSkyblock.java
@@ -0,0 +1,39 @@
+package net.minecraft.core.world.type.overworld;
+
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biomes;
+import net.minecraft.core.world.biome.provider.BiomeProvider;
+import net.minecraft.core.world.biome.provider.BiomeProviderSingleBiome;
+import net.minecraft.core.world.generate.chunk.ChunkGenerator;
+import net.minecraft.core.world.generate.chunk.skyblock.ChunkGeneratorSkyblock;
+
+public class WorldTypeOverworldSkyblock
+        extends WorldTypeOverworld {
+    public WorldTypeOverworldSkyblock(Properties properties) {
+        super(properties);
+    }
+
+    @Override
+    public BiomeProvider createBiomeProvider(World world) {
+        return new BiomeProviderSingleBiome(Biomes.OVERWORLD_PLAINS, 1.0, 1.0, 1.0);
+    }
+
+    @Override
+    public ChunkGenerator createChunkGenerator(World world) {
+        return new ChunkGeneratorSkyblock(world);
+    }
+
+    @Override
+    public boolean isValidSpawn(World world, int x, int y, int z) {
+        return true;
+    }
+
+    @Override
+    public void getInitialSpawnLocation(World world) {
+        world.getLevelData().setSpawn(0, 66, 0);
+    }
+
+    @Override
+    public void getRespawnLocation(World world) {
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldWoods.java b/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldWoods.java
new file mode 100644
index 000000000..4f56a5d42
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldWoods.java
@@ -0,0 +1,17 @@
+package net.minecraft.core.world.type.overworld;
+
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.chunk.ChunkGenerator;
+import net.minecraft.core.world.generate.chunk.perlin.overworld.woods.ChunkGeneratorOverworldWoods;
+
+public class WorldTypeOverworldWoods
+        extends WorldTypeOverworld {
+    public WorldTypeOverworldWoods(Properties properties) {
+        super(properties);
+    }
+
+    @Override
+    public ChunkGenerator createChunkGenerator(World world) {
+        return new ChunkGeneratorOverworldWoods(world);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/type/paradise/WorldTypeParadise.java b/src/main/java/net/minecraft/core/world/type/paradise/WorldTypeParadise.java
new file mode 100644
index 000000000..1149d1c9d
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/type/paradise/WorldTypeParadise.java
@@ -0,0 +1,147 @@
+package net.minecraft.core.world.type.paradise;
+
+import net.minecraft.client.render.colorizer.Colorizers;
+import net.minecraft.core.Global;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biomes;
+import net.minecraft.core.world.biome.provider.BiomeProvider;
+import net.minecraft.core.world.biome.provider.BiomeProviderSingleBiome;
+import net.minecraft.core.world.config.season.SeasonConfig;
+import net.minecraft.core.world.generate.chunk.ChunkGenerator;
+import net.minecraft.core.world.generate.chunk.perlin.paradise.ChunkGeneratorParadise;
+import net.minecraft.core.world.season.Seasons;
+import net.minecraft.core.world.type.WorldType;
+
+public class WorldTypeParadise
+        extends WorldType {
+    public WorldTypeParadise(Properties properties) {
+        super(properties);
+    }
+
+    public static Properties defaultProperties(String translationKey) {
+        return Properties.of(translationKey)
+                .brightnessRamp(createLightRamp())
+                .seasonConfig(SeasonConfig.builder()
+                        .withSeasonInCycle(Seasons.PARADISE_GOLD, 28)
+                        .withSeasonInCycle(Seasons.PARADISE_SILVER, 28)
+                        .build()
+                )
+                .fillerBlock(Blocks.MARBLE)
+                .dayNightCycleTicks(Global.DAY_LENGTH_TICKS * 28 * 2)
+                .cloudHeight(8f)
+                .noGround()
+                .bounds(0, 255, 0);
+    }
+
+    private static float[] createLightRamp() {
+        float[] brightnessRamp = new float[32];
+        float f = 0.05F;
+        for (int i = 0; i <= 31; i++) {
+            float f1 = 1.0F - (float) i / 15F;
+            if (i > 15) f1 = 0.0f;
+            brightnessRamp[i] = ((1.0F - f1) / (f1 * 3F + 1.0F)) * (1.0F - f) + f;
+        }
+        return brightnessRamp;
+    }
+
+    @Override
+    public void onWorldCreation(World world) {
+        super.onWorldCreation(world);
+
+        world.setWorldTime(576000);
+    }
+
+    @Override
+    public BiomeProvider createBiomeProvider(World world) {
+        return new BiomeProviderSingleBiome(Biomes.PARADISE_PARADISE, 0.5, 0.0, 0.0);
+    }
+
+    @Override
+    public ChunkGenerator createChunkGenerator(World world) {
+        return new ChunkGeneratorParadise(world);
+    }
+
+    @Override
+    public boolean isValidSpawn(World world, int x, int y, int z) {
+        return true;
+    }
+
+    @Override
+    public float getCelestialAngle(World world, long tick, float partialTick) {
+        float dayProgress = getTimeOfDay(world, tick, partialTick);
+        dayProgress -= 0.25f;
+        float f2 = dayProgress;
+        dayProgress = 1.0F - (float) ((Math.cos((double) dayProgress * Math.PI) + 1.0D) / 2D);
+        dayProgress = f2 + (dayProgress - f2) / 3F;
+        return dayProgress;
+    }
+
+    @Override
+    public float[] getSunriseColor(float timeOfDay, float partialTick) {
+        float[] sunriseCol = new float[4];
+        float f2 = 0.4F;
+        float f3 = MathHelper.cos(timeOfDay * MathHelper.PI * 2.0F) - 0.0F;
+        float f4 = -0F;
+        if (f3 >= f4 - f2 && f3 <= f4 + f2) {
+            float c = ((f3 - f4) / f2) * 0.5F + 0.5F;
+            float a = 1.0F - (1.0F - MathHelper.sin(c * MathHelper.PI)) * 0.99F;
+            a *= a;
+            sunriseCol[0] = c * 0.3F + 0.7F;
+            sunriseCol[1] = c * c * 0.7F + 0.2F;
+            sunriseCol[2] = c * c * 0.0F + 0.2F;
+            sunriseCol[3] = a;
+            return sunriseCol;
+        } else {
+            return null;
+        }
+    }
+
+    @Override
+    public int getSkyDarken(World world, long tick, float partialTick) {
+        float f1 = getCelestialAngle(world, tick, partialTick);
+        float f2 = 1.0F - (MathHelper.cos(f1 * MathHelper.PI * 2.0F) * 2.0F + 0.5F);
+        if (f2 < 0.0F) {
+            f2 = 0.0F;
+        }
+        if (f2 > 1.0F) {
+            f2 = 1.0F;
+        }
+        float weatherOffset = 0;
+        if (world.getCurrentWeather() != null)
+            weatherOffset = world.getCurrentWeather().subtractLightLevel * world.weatherManager.getWeatherIntensity() * world.weatherManager.getWeatherPower();
+        int subtracted = (int) (f2 * (11F - weatherOffset) + weatherOffset);
+        if (subtracted > 8) subtracted = 8;
+        return subtracted;
+    }
+
+    @Override
+    public Vec3 getFogColor(World world, double x, double y, double z, float celestialAngle, float partialTick) {
+        float f2 = MathHelper.cos(celestialAngle * MathHelper.PI * 2.0F) * 2.0F + 0.5F;
+        f2 = MathHelper.clamp(f2, 0.0f, 1.0f);
+        float r, g, b;
+
+        if (Colorizers.fog.isEnabled()) {
+            int x1 = MathHelper.floor(x);
+            int y1 = MathHelper.floor(y);
+            int z1 = MathHelper.floor(z);
+
+            int color = Colorizers.fog.getColor(world, x1, y1, z1);
+
+            r = ((color >> 16) & 0xFF) / 255.0f;
+            g = ((color >> 8) & 0xFF) / 255.0f;
+            b = (color & 0xFF) / 255.0f;
+        } else {
+            int i = 0x8080a0;
+            r = (float) (i >> 16 & 0xff) / 255.0f;
+            g = (float) (i >> 8 & 0xff) / 255.0f;
+            b = (float) (i & 0xff) / 255.0f;
+        }
+        r *= f2 * 0.94F + 0.06F;
+        g *= f2 * 0.94F + 0.06F;
+        b *= f2 * 0.91F + 0.09F;
+        return Vec3.getTempVec3(r, g, b);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/weather/Weather.java b/src/main/java/net/minecraft/core/world/weather/Weather.java
index 39fce5dd2..e900858ba 100644
--- a/src/main/java/net/minecraft/core/world/weather/Weather.java
+++ b/src/main/java/net/minecraft/core/world/weather/Weather.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.world.weather;
 
-import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.chunk.Chunk;
@@ -21,8 +21,8 @@ public abstract class Weather
 	
 	public Weather(int id)
 	{
-		if(weatherList[id] != null) throw new RuntimeException();
-		weatherList[id] = this;
+		if(Weathers.WEATHERS[id] != null) throw new RuntimeException();
+		Weathers.WEATHERS[id] = this;
 		this.weatherId = id;
 	}
 	
@@ -102,7 +102,7 @@ public abstract class Weather
 
 			if (world.getBlockBiome(x, y, z).hasSurfaceSnow())
 			{
-				if (blockId == Block.layerSnow.id)
+				if (blockId == Blocks.LAYER_SNOW.id)
 				{
 					int meta = world.getBlockMetadata(x, y, z);
 					if (meta != 0)
@@ -114,7 +114,7 @@ public abstract class Weather
 			}
 			else
 			{
-				if (blockId == Block.layerSnow.id)
+				if (blockId == Blocks.LAYER_SNOW.id)
 				{
 					int meta = world.getBlockMetadata(x, y, z);
 					if (meta != 0)
@@ -127,9 +127,9 @@ public abstract class Weather
 						world.setBlockWithNotify(x, y, z, 0);
 					}
 				}
-				else if (blockIdBelow == Block.ice.id)
+				else if (blockIdBelow == Blocks.ICE.id)
 				{
-					world.setBlockWithNotify(x, y - 1, z, Block.fluidWaterStill.id);
+					world.setBlockWithNotify(x, y - 1, z, Blocks.FLUID_WATER_STILL.id);
 				}
 			}
 		}
@@ -151,47 +151,23 @@ public abstract class Weather
 
 				if (world.getBlockBiome(chunk.xPosition * 16 + x, y, chunk.zPosition * 16 + z).hasSurfaceSnow())
 				{
-					if (blockId == Block.layerSnow.id)
+					if (blockId == Blocks.LAYER_SNOW.id)
 					{
 						chunk.setBlockMetadata(x, y, z, 0);
 					}
 				}
 				else
 				{
-					if (blockId == Block.layerSnow.id)
+					if (blockId == Blocks.LAYER_SNOW.id)
 					{
 						chunk.setBlockID(x, y, z, 0);
 					}
-					else if (blockIdBelow == Block.ice.id)
+					else if (blockIdBelow == Blocks.ICE.id)
 					{
-						chunk.setBlockID(x, y - 1, z, Block.fluidWaterStill.id);
+						chunk.setBlockID(x, y - 1, z, Blocks.FLUID_WATER_STILL.id);
 					}
 				}
 			}
 		}
 	}
-	
-	public static Weather getWeatherByLanguageKey(String string) {
-		for(Weather weather : Weather.weatherList) {
-			if(weather != null && weather.languageKey.substring(8).equalsIgnoreCase(string)) {
-				return weather;
-			}
-		}
-		return null;
-	}
-	
-	public static Weather getWeather(int i) {
-		return weatherList[i];
-	}
-	
-	public static final Weather[] weatherList = new Weather[16];
-	public static final Weather overworldClear = new WeatherClear(0).setLanguageKey("overworld.clear");
-	public static final Weather overworldRain = new WeatherRain(1).setLanguageKey("overworld.rain").setPrecipitation("/environment/rain.png", 0).setSubtractLightLevel(3).setSpawnRainParticles(true).setFogDistance(0.5f);
-	public static final Weather overworldSnow = new WeatherSnow(2).setLanguageKey("overworld.snow").setPrecipitation("/environment/snow.png", 1).setSubtractLightLevel(1).setFogDistance(0.5f);
-	public static final Weather overworldStorm = new WeatherStorm(3).setLanguageKey("overworld.storm").setPrecipitation("/environment/rain.png", 0).setSubtractLightLevel(5).setSpawnRainParticles(true).setMobsSpawnInDaylight().setFogDistance(0.4f);
-	public static final Weather overworldFog = new WeatherClear(4).setLanguageKey("overworld.fog").setFogDistance(0.125f);
-	public static final Weather overworldHellClear = new WeatherClear(5).setLanguageKey("overworld.clear.hell").setSubtractLightLevel(7);
-	public static final Weather overworldWoodsClear = new WeatherClear(6).setLanguageKey("overworld.clear.woods").setSubtractLightLevel(2);
-	public static final Weather overworldWinterSnow = new WeatherSnow(7).setLanguageKey("overworld.winter.snow").setPrecipitation("/environment/snow.png", 1);
-	public static final Weather overworldRainBlood = new WeatherStorm(8).setLanguageKey("overworld.rain.blood").setPrecipitation("/environment/rain_blood.png", 2).setSubtractLightLevel(5).setMobsSpawnInDaylight().setFogDistance(0.4f);
 }
diff --git a/src/main/java/net/minecraft/core/world/weather/WeatherClear.java b/src/main/java/net/minecraft/core/world/weather/WeatherClear.java
index 6fa24f6e3..8a3f4a9cb 100644
--- a/src/main/java/net/minecraft/core/world/weather/WeatherClear.java
+++ b/src/main/java/net/minecraft/core/world/weather/WeatherClear.java
@@ -2,6 +2,7 @@ package net.minecraft.core.world.weather;
 
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.chunk.Chunk;
 
 import java.util.Random;
diff --git a/src/main/java/net/minecraft/core/world/weather/WeatherRain.java b/src/main/java/net/minecraft/core/world/weather/WeatherRain.java
index 68966aa58..af3d5cccd 100644
--- a/src/main/java/net/minecraft/core/world/weather/WeatherRain.java
+++ b/src/main/java/net/minecraft/core/world/weather/WeatherRain.java
@@ -2,6 +2,7 @@ package net.minecraft.core.world.weather;
 
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 
 import java.util.Random;
 
diff --git a/src/main/java/net/minecraft/core/world/weather/WeatherSnow.java b/src/main/java/net/minecraft/core/world/weather/WeatherSnow.java
index adc52ac52..4a82a9c4b 100644
--- a/src/main/java/net/minecraft/core/world/weather/WeatherSnow.java
+++ b/src/main/java/net/minecraft/core/world/weather/WeatherSnow.java
@@ -3,8 +3,8 @@ package net.minecraft.core.world.weather;
 import java.util.Random;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFluidStill;
-import net.minecraft.core.block.BlockLayerSnow;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.SnowLayerBlock;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
@@ -25,11 +25,11 @@ public class WeatherSnow extends Weather
 	{
 		if (world.weatherManager.getWeatherPower() <= 0.6f)
 		{
-			return "/environment/snow_light.png";
+			return "/assets/minecraft/textures/environment/snow_light.png";
 		}
 		else
 		{
-			return "/environment/snow.png";
+			return "/assets/minecraft/textures/environment/snow.png";
 		}
 	}
 
@@ -56,14 +56,14 @@ zLoop:		for (int z = 0; z < 16; z++)
 
 				if (y >= 0 && y < world.getHeightBlocks() && chunk.getBrightness(LightLayer.Block, x, y, z) < 10)
 				{
-					if (blockId == 0 && Block.layerSnow.canPlaceBlockAt(world, worldX, y, worldZ) && blockIdBelow != Block.ice.id)
+					if (blockId == 0 && Blocks.LAYER_SNOW.canPlaceBlockAt(world, worldX, y, worldZ) && blockIdBelow != Blocks.ICE.id)
 					{
-						chunk.setBlockIDRaw(x, y, z, Block.layerSnow.id);
+						chunk.setBlockIDRaw(x, y, z, Blocks.LAYER_SNOW.id);
 					}
-					else if (blockIdBelow == Block.fluidWaterStill.id && chunk.getBlockMetadata(x, y - 1, z) == 0) {
-						chunk.setBlockIDRaw(x, y - 1, z, Block.ice.id);
-						if (chunk.getBlockID(x, y - 2, z) == Block.fluidWaterStill.id){
-							chunk.setBlockIDRaw(x, y - 2, z, Block.fluidWaterFlowing.id);
+					else if (blockIdBelow == Blocks.FLUID_WATER_STILL.id && chunk.getBlockMetadata(x, y - 1, z) == 0) {
+						chunk.setBlockIDRaw(x, y - 1, z, Blocks.ICE.id);
+						if (chunk.getBlockID(x, y - 2, z) == Blocks.FLUID_WATER_STILL.id){
+							chunk.setBlockIDRaw(x, y - 2, z, Blocks.FLUID_WATER_FLOWING.id);
 						}
 					}
 				}
@@ -95,20 +95,20 @@ zLoop:		for (int z = 0; z < 16; z++)
 		
 		if (world.weatherManager.getWeatherPower() > 0.6f && y >= 0 && y < world.getHeightBlocks() && world.getSavedLightValue(LightLayer.Block, x, y, z) < 10)
 		{
-			if (blockId == 0 && blockIdBelow != 0 && Block.layerSnow.canPlaceBlockAt(world, x, y, z) && blockIdBelow != Block.ice.id)
+			if (blockId == 0 && blockIdBelow != 0 && Blocks.LAYER_SNOW.canPlaceBlockAt(world, x, y, z) && blockIdBelow != Blocks.ICE.id)
 			{
 				if(snow)
 				{
-					world.setBlockWithNotify(x, y, z, Block.layerSnow.id);
+					world.setBlockWithNotify(x, y, z, Blocks.LAYER_SNOW.id);
 				}
 			}
-			else if (world.weatherManager.getWeatherPower() > 0.5f && blockId == Block.layerSnow.id && world.getSeasonManager().getCurrentSeason() != null && (world.getSeasonManager().getCurrentSeason().hasDeeperSnow || biome == Biomes.OVERWORLD_GLACIER))
+			else if (world.weatherManager.getWeatherPower() > 0.5f && blockId == Blocks.LAYER_SNOW.id && world.getSeasonManager().getCurrentSeason() != null && (world.getSeasonManager().getCurrentSeason().hasDeeperSnow || biome == Biomes.OVERWORLD_GLACIER))
 			{
 				if(snow) {
-					((BlockLayerSnow)Block.layerSnow).accumulate(world, x, y, z);
+					((SnowLayerBlock)Blocks.LAYER_SNOW).accumulate(world, x, y, z);
 				}
 			}
-			else if (blockIdBelow == Block.fluidWaterStill.id && world.getBlockMetadata(x, y - 1, z) == 0)
+			else if (blockIdBelow == Blocks.FLUID_WATER_STILL.id && world.getBlockMetadata(x, y - 1, z) == 0)
 			{
 				if(rand.nextFloat() < world.weatherManager.getWeatherPower() * world.weatherManager.getWeatherIntensity())
 				{
@@ -116,9 +116,9 @@ zLoop:		for (int z = 0; z < 16; z++)
 					{
 						Direction direction = Direction.horizontalDirections[i];
 						Block block = world.getBlock(x + direction.getOffsetX(), y - 1, z + direction.getOffsetZ());
-						if(block == Block.ice || block != null && block.isSolidRender())
+						if(block == Blocks.ICE || block != null && block.isSolidRender())
 						{
-							world.setBlockWithNotify(x, y - 1, z, Block.ice.id);
+							world.setBlockWithNotify(x, y - 1, z, Blocks.ICE.id);
 							break;
 						}
 					}	
diff --git a/src/main/java/net/minecraft/core/world/weather/WeatherStorm.java b/src/main/java/net/minecraft/core/world/weather/WeatherStorm.java
index b2216c480..5a1b384e7 100644
--- a/src/main/java/net/minecraft/core/world/weather/WeatherStorm.java
+++ b/src/main/java/net/minecraft/core/world/weather/WeatherStorm.java
@@ -1,8 +1,14 @@
 package net.minecraft.core.world.weather;
 
-import net.minecraft.core.entity.EntityLightningBolt;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.LightningEntity;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 
+import java.util.List;
 import java.util.Random;
 
 public class WeatherStorm extends WeatherRain
@@ -29,15 +35,53 @@ public class WeatherStorm extends WeatherRain
 	{
 		super.doEnvironmentUpdate(world, rand, x, z);
 		
-		if (rand.nextInt((int)(0x186a0 * (1 / world.weatherManager.getWeatherPower()))) == 0) // Yes this is a weird value, it's what it used before, don't @ me
+		if (rand.nextInt((int)(100000 * (1 / world.weatherManager.getWeatherPower()))) == 0)
 		{
-			int y = world.getHeightValue(x, z);
-			
-			if (world.canBlockBeRainedOn(x, y, z))
+			final int searchRadius = 32;
+
+			int maxWeight = Integer.MIN_VALUE;
+			int targetX = x;
+			int targetY = world.getHeightValue(x, z);
+			int targetZ = z;
+			for (int _x = -searchRadius; _x <= searchRadius; _x++) {
+				for (int _z = -searchRadius; _z < searchRadius; _z++) {
+					int checkX = x + _x;
+					int checkZ = z + _z;
+					int checkY = world.getHeightValue(checkX, checkZ);
+					int weight = evalStrikeWeight(world, rand, x, z, checkX, checkY, checkZ);
+					if (weight > maxWeight){
+						maxWeight = weight;
+						targetX = checkX;
+						targetY = checkY;
+						targetZ = checkZ;
+					}
+				}
+			}
+
+			if (world.canBlockBeRainedOn(targetX, targetY, targetZ))
 			{
-				world.addWeatherEffect(new EntityLightningBolt(world, x, y, z));
+				world.addWeatherEffect(new LightningEntity(world, targetX, targetY, targetZ));
 			}			
 		}
 	}
+	public int evalStrikeWeight(World world, Random random, int orgX, int orgZ, int checkX, int checkY, int checkZ){
+		Material material = world.getBlockMaterial(checkX, checkY - 1, checkZ);
+		int weight = random.nextInt(10);
+		weight += checkY;
+		weight += material.getConductivity();
+
+		List<Entity> entityList = world.getEntitiesWithinAABB(Mob.class, AABB.getTemporaryBB(checkX, checkY, checkZ, checkX + 1, checkY + 1, checkZ + 1));
+		if (!entityList.isEmpty()){
+			weight += 4; // :)
+		}
+
+		final int distX =  (checkX - orgX);
+		final int distZ =  (checkZ - orgZ);
+		final double dist = Math.sqrt(distX * distX + distZ + distZ);
+		final int decayFactor = MathHelper.floor(Math.sqrt(dist) / 4);
+		weight -= decayFactor;
+
+		return weight;
+	}
 
 }
diff --git a/src/main/java/net/minecraft/core/world/weather/Weathers.java b/src/main/java/net/minecraft/core/world/weather/Weathers.java
new file mode 100644
index 000000000..49e438226
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/weather/Weathers.java
@@ -0,0 +1,28 @@
+package net.minecraft.core.world.weather;
+
+public abstract class Weathers {
+    public static final Weather[] WEATHERS = new Weather[16];
+    public static final Weather OVERWORLD_CLEAR = new WeatherClear(0).setLanguageKey("overworld.clear");
+    public static final Weather OVERWORLD_RAIN = new WeatherRain(1).setLanguageKey("overworld.rain").setPrecipitation("/assets/minecraft/textures/environment/rain.png", 0).setSubtractLightLevel(3).setSpawnRainParticles(true).setFogDistance(0.5f);
+    public static final Weather OVERWORLD_SNOW = new WeatherSnow(2).setLanguageKey("overworld.snow").setPrecipitation("/assets/minecraft/textures/environment/snow.png", 1).setSubtractLightLevel(1).setFogDistance(0.5f);
+    public static final Weather OVERWORLD_STORM = new WeatherStorm(3).setLanguageKey("overworld.storm").setPrecipitation("/assets/minecraft/textures/environment/rain.png", 0).setSubtractLightLevel(5).setSpawnRainParticles(true).setMobsSpawnInDaylight().setFogDistance(0.4f);
+    public static final Weather OVERWORLD_FOG = new WeatherClear(4).setLanguageKey("overworld.fog").setFogDistance(0.125f);
+    public static final Weather OVERWORLD_CLEAR_HELL = new WeatherClear(5).setLanguageKey("overworld.clear.hell").setSubtractLightLevel(7);
+    public static final Weather OVERWORLD_CLEAR_WOODS = new WeatherClear(6).setLanguageKey("overworld.clear.woods").setSubtractLightLevel(2);
+    public static final Weather OVERWORLD_WINTER_SNOW = new WeatherSnow(7).setLanguageKey("overworld.winter.snow").setPrecipitation("/assets/minecraft/textures/environment/snow.png", 1);
+    public static final Weather OVERWORLD_RAIN_BLOOD = new WeatherStorm(8).setLanguageKey("overworld.rain.blood").setPrecipitation("/assets/minecraft/textures/environment/rain_blood.png", 2).setSubtractLightLevel(5).setMobsSpawnInDaylight().setFogDistance(0.4f);
+
+    public static Weather getWeatherByLanguageKey(String string) {
+        for(Weather weather : WEATHERS) {
+            if(weather != null && weather.languageKey.substring(8).equalsIgnoreCase(string)) {
+                return weather;
+            }
+        }
+        return null;
+    }
+
+    public static Weather getWeather(int i) {
+        return WEATHERS[i];
+    }
+
+}
diff --git a/src/main/java/net/minecraft/core/world/wind/WindManager.java b/src/main/java/net/minecraft/core/world/wind/WindProvider.java
similarity index 93%
rename from src/main/java/net/minecraft/core/world/wind/WindManager.java
rename to src/main/java/net/minecraft/core/world/wind/WindProvider.java
index 2ad583ce6..d8846765e 100644
--- a/src/main/java/net/minecraft/core/world/wind/WindManager.java
+++ b/src/main/java/net/minecraft/core/world/wind/WindProvider.java
@@ -2,7 +2,7 @@ package net.minecraft.core.world.wind;
 
 import net.minecraft.core.world.World;
 
-public abstract class WindManager {
+public abstract class WindProvider {
     /**
      * Gets the current wind direction.
      * @param world The world.
